#!/usr/local/bin/perl
#	Copyright(C)2001 Ktat, All rights reserved.

use 5.004;
use strict;
use CGI;
use Schedule;
use CGI::Carp qw(fatalsToBrowser);	# for Debug

my $version = 'ver. 1.23';

# Initial Setting
my $dir 	 = "./data";		# f[^fBNg̏ꏊ
my $cgi_title= "Scheduler";		# ^Cg
my $caltype  = "Long";			# Long(ꗗ) or Short(ڍ) or 3month(3)
my $method   = "get";			# \؂ւ̃\bh
my $method2  = "get";			# ̃\bh(post)
my $time_d	 = 9;				# GMTƂ̎
my @events	 = ('c','o','݉','V','̑');	# ͍̑ŌɂĉBIȂꍇ̃ftHgɂȂ܂B
my @word	 = ("word.dat");	# ̌t̓t@CNH[g͂݁AR}؂œ(ȂȂ폜)B
my $min      = 10;				# włŏ݂̐̌̍(ŏ̐ = ݂̐ - $min)
my $max      = 90;				# włő݂̐̌̕(ő̐ = ݂̐ + $max)
my $back_word= "߂";			# ߂郊Ňt(摜)
my $back_link= "../../../scheduler.html";	# ߂ꏊ
my $form_on  = 1;				# 0 œetH[\B\ꍇ́Ascheduler.cgi?form_on=1 ɂB
my $cgi_name = "scheduler.cgi";	# CGI Script̖O
my $admin    = 0;				# Ǘ҂̂ݓeȂ1

# You needn't change code under here.

my $cgi  = new CGI;
my %cookie = $cgi->cookie("Schedule");
my $year;
my $month;
my $today;
my %RS;
my @er_message;

{
	my($year,$month);
	($today,$month,$year) = (gmtime time + $time_d * 3600)[3,4,5];
	$year +=1900;
	$today = $year.substr("0".++$month,-2).substr("0".$today,-2);
	$min = $year - $min;
	$max += $year;
}

foreach my $key ($cgi->param){
	my @value = $cgi->param($key);
	$RS{$key} = $value[0];
	$year  = $value[0]	if $key eq "year";
	$month = $value[0]	if $key eq "month";
	$form_on=$value[0]	if $key eq "form_on";
}

$form_on += 1	if $RS{'form_change'} == 1;
$form_on = 1	if $form_on > 2;


$caltype = exists $RS{Short} ? 'Short' : exists $RS{Long} ? 'Long' : exists $RS{'3month'} ? '3month' : exists $RS{'day_specified'} ? 'day_specified' : $caltype;

if($year ne "" and $month ne "" and $year < $min or $year > $max){
	if($year < $min){
		$year = $min;
		$month= 1;
	}elsif($year > $max){
		$year = $max;
		$month= 12;
	}
}

if(exists $RS{Date}){
my($m,$y) = (substr($RS{Date},-4,2),substr($RS{Date},0,4));
if($m <= 12 and $m >= 1 and $y >= $min and $y <= $max){
	if(exists $RS{Delete}){# Delete Schedule.
		($year,$month) = (substr($RS{Date},0,4),substr($RS{Date},-4,2));
		my $sch = new Schedule ($dir,$year,$month,$admin);
		$sch->cancel(\%RS);
		$sch->rec_db;
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}elsif(exists $RS{Write} and exists $RS{content}){# Record Schedule.
		($year,$month) = (substr($RS{Date},0,4),substr($RS{Date},-4,2));
		my $sch = new Schedule ($dir,$year,$month,$admin);
		$RS{event} = $#events	if $RS{event} eq "";
		if($sch->reserve(\%RS)){
			$sch->rec_db;
			%cookie = %RS;
		}
		$cookie{content} = "";
		$cookie{subject} = "";
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}elsif(exists $RS{Replace}){
		($year,$month) = (substr($RS{Date},0,4),substr($RS{Date},-4,2));
		my $sch = new Schedule ($dir,$year,$month,$admin);
		if($sch->replace(\%RS)){
			$sch->rec_db;
			%cookie = %RS;
		}
		$cookie{content} = "";
		$cookie{subject} = "";
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}
}
}else{
	if(exists $RS{SpDelete}){# Delete SpSchedule.
		my $sch = new Schedule ($dir,$year,$month,$admin);
		$sch->sp_cancel(\%RS);
		$sch->rec_sp_db;
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}elsif(exists $RS{SpWrite}){# Record SpSchedule.
		my $sch = new Schedule ($dir,$year,$month,$admin);
		$RS{event} = $#events	if $RS{event} eq "";
		if($sch->sp_reserve(\%RS)){
			$sch->rec_sp_db;
			%cookie = %RS;
		}
		$cookie{content} = "";
		$cookie{subject} = "";
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}elsif(exists $RS{SpReplace}){
		my $sch = new Schedule ($dir,$year,$month,$admin);
		if($sch->sp_replace(\%RS)){
			$sch->rec_sp_db;
			%cookie = %RS;
		}
		$cookie{content} = "";
		$cookie{subject} = "";
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}
	($year,$month) = (substr($RS{TrueDate},0,4),substr($RS{TrueDate},-2))	if $RS{TrueDate};
}

my $cookie = $cgi->cookie(-name=>'Schedule',-value=>\%cookie,-expires=>"+720h");

if($year < 0 or $year eq ""){
	($month,$year) = (gmtime time + $time_d * 3600)[4,5];
	$month++;
	$year+=1900;
}

$month = substr("0".$month,-2);
$year = substr("000".$year,-4);

!-e "$dir/password" ? make_pass() : $caltype eq 'day_specified' ? day_sp($RS{'day_specified'}) : appear();

sub day_sp{
	my $day = substr('0'.shift,-2);
	%RS = ();
	my @days = qw(      y);
	my $cal  = new Calendar ($year,$month);
	my $sch  = new Schedule ($dir,$year,$month,$admin);
	my $date = $year.$month.$day;
	my $mon = $month;
	my ($special,$special_name) = $cal->search($day);
	$mon+=0;
	$, = "\n";
	print $cgi->header(-cookie => $cookie, -charset => 'Shift_JIS'),
		$cgi->start_html(-title => $cgi_title, -style=>{'src'=>'./calendar.css'}),
		"<div align=center>",
		$cgi->h1("$year/$month/$day (".$days[$cal->calc($day)].")"),
		$cgi->h2(join(" ",@{$special_name}));
	foreach(@{$sch->get_sp_reserved($date)}){
		my($name,$mail,$subject,$content,$date) = (split /<>/)[0,1,3,4,5];
		$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
		$subject=~s/^(\d?)>(\w+)>//;
		print $1 != 1 ? qq(<h2 class="$2">$subject</h2>\n<h3>$content</h3>\n) : qq(<h2 class="$2">$subject</h2>\n);
	}
	print "</div>";
	print qq(<table width="80%" align=center>\n<tr><td align=center class=form>),
		$cgi->startform(-method=>$method),
		$cgi->hidden(-value => $form_on,-name=>'form_on'),
		$cgi->hidden(-value => $mon,-name=>'month'),
		$cgi->hidden(-value => $year,-name=>'year'),
		$cgi->submit(-value => 'ꗗ',-name=>'Long'),
		$cgi->submit(-value => 'ڍ',-name=>'Short'),
		$cgi->submit(-value => '3',-name=>'3month'),
		$cgi->endform,
		"</td></tr></table>\n";
	foreach(@{$sch->get_reserved($date)}){
		my($name,$mail,$subject,$content,$date) = (split /<>/)[0,1,3,4,5];
		$name = $mail ? qq( <A href="mailto:$mail">$name</a> ) : " ( $name )";
		$subject=~s/(\d+)>//;
		print qq(<table border=1 width="80%" cellspacing=0 align=center>\n);
		print qq(<tr><td class="sub$1">[$events[$1]] $subject ( $name )</td></tr>\n);
		print qq(<tr><td class=normal>$content\n);
		print qq(<div align="right">).time_convert($date)."</div>\n";
		print qq(</td></tr>\n</table><br>\n);
	}
	print qq(<table width="80%" align=center>\n<tr><td align=center class=form>),
		$cgi->startform(-method=>$method),
		$cgi->hidden(-value => $form_on, -name=>'form_on'),
		$cgi->hidden(-value => $mon,-name=>'month'),
		$cgi->hidden(-value => $year,-name=>'year'),
		$cgi->submit(-value => 'ꗗ',-name=>'Long'),
		$cgi->submit(-value => 'ڍ',-name=>'Short'),
		$cgi->submit(-value => '3',-name=>'3month'),
		$cgi->endform,
		"</td></tr></table>\n";
	print qq(<div align=center>- <a href="http://www.pure.ne.jp/~learner/">Simple Scheduler $version</a> - </div><br>),
		$cgi->end_html;
		push(@er_message,$sch->{'message'})	if $sch->{'message'};
}


sub appear{# Appear Screen
	%RS = ();
	my @days = qw(      y);
	my $days;
	my $day  = 0;
	my $links;
	my $mon = $month;
	$mon+=0;
	{
		my $yea = $year;
		my $mode = "$caltype=on";
		my($n_mon,$n_yea) = (gmtime time + $time_d * 3600)[4,5];
		$n_mon++;$n_yea+=1900;
		if($month eq "01"){
			$links = qq(<a href="$cgi_name?$mode&year=).($yea-1)."&month=12&CalType=$caltype&form_on=$form_on".qq(">&lt; last</a>
				 <a href="$cgi_name?$mode&year=$n_yea&month=$n_mon&CalType=$caltype&form_on=$form_on"></a>
				 <a href="$cgi_name?$mode&year=$yea&month=2&CalType=$caltype&form_on=$form_on"> next &gt;</a>);
		}elsif($month eq "12"){
			$links = qq(<a href="$cgi_name?$mode&year=$yea&month=11&CalType=$caltype&form_on=$form_on">&lt; last</a>
				 <a href="$cgi_name?$mode&year=$n_yea&month=$n_mon&CalType=$caltype&form_on=$form_on"></a>
				 <a href="$cgi_name?$mode&year=).($yea+1)."&month=1&CalType=$caltype&form_on=$form_on".qq("> next &gt;</a>);
		}else{
			$links = qq(<a href="$cgi_name?$mode&year=$yea&month=).($mon-1).qq(&CalType=$caltype&form_on=$form_on">&lt; last</a>
				 <a href="$cgi_name?$mode&year=$n_yea&month=$n_mon&CalType=$caltype&form_on=$form_on"></a>
				 <a href="$cgi_name?$mode&year=$yea&month=).($mon+1).qq(&CalType=$caltype&form_on=$form_on"> next &gt;</a>);
		}
	}
	print $cgi->header(-cookie => $cookie, -charset => 'Shift_JIS'),
		$cgi->start_html(-title => $cgi_title, -style=>{'src'=>'./calendar.css'}),
		qq(\n<div class=title><span class="title">$year/$month</span> <span class=links>$links</span></div>\n);

	# R\

	if($caltype eq '3month'){
	my @month= (
		[ $year,($month-1) ],
		[ $year,$month ],
		[ $year,($month+1) ]
	);
	($month[0]->[0]--,$month[0]->[1] = 12)	if $month[0]->[1] == 0;
	($month[2]->[0]++,$month[2]->[1] = 1)	if $month[2]->[1] == 13;
	$month[1]->[1] += 0;
	print qq(<table cellspacing=0 align=left width="70%">\n);
	print qq(<TR><TH>$month[0]->[1]</TH><TH>$month[1]->[1]</TH><TH>$month[2]->[1]</TH></TR>\n<TR>);
	foreach my $months (@month){
		print "<TD valign=top>";
		my $day = 0;
		my($year,$month) = @{$months};
		my $mon = $month = substr("0".$month,-2);
		my $cal  = new Calendar ($year,$month);
		my $sch  = new Schedule ($dir,$year,$month,$admin);
		my $fday = $cal->{fday};
		my $days = $cal->{days};
		$mon += 0;
		print qq(<table BORDER=1 cellspacing=0 class=calendar>\n<TR><TH class="cal" width="1%" nowrap>Day</TH><TH class="cal"> Schedule </TH></TR>\n);
		while(++$day <= $days){
			my $contents = 0;
			my $date = $year.$month.substr("0".$day,-2);
			my($special,$special_name) = $cal->search($day);
			my @gets_sp= @{$sch->get_sp_reserved($date)};
			my @gets   = @{$sch->get_reserved($date)};
			$special = "rest"	if $fday == 0;
			$special ="today"	if $date == $today;
			print "\n<TR><TD align=right valign=top class=$special nowrap><nobr>";
			print @gets == 0 ? "$day<span class=day>($days[$fday])</span>" : qq(<a href="$cgi_name?day_specified=$day&year=$year&month=$mon&form_on=$form_on">$day(<span class=day>$days[$fday])</span></a>);
			print "</nobr></TD><TD class=$special>";
			foreach my $name (@{$special_name}){
				print $name."<br>\n";
				$contents++;
			}
			foreach(@gets_sp){
				my($name,$mail,$subject,$content,$date) = (split /<>/)[0,1,3,4,5];
				$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
				$subject=~s/^(\d?)>(\w+)>//;
				$name = ""	if $1 == 1;
				print qq(<span class="$2">$subject</span> $name<br>\n);
				$contents++
			}
			foreach(@gets){
				my($name,$mail,$subject) = (split /<>/)[0,1,3];
				$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
				$subject=~s/^(\d+)>//;
				print qq(<span class="sub$1">$events[$1]</span> $name<br>\n);
				$contents++
			}
			print $contents > 0 ? "</TD></TR>" : "@</TD></TR>";
			$fday = 0	if ++$fday > 6;
			push(@er_message,$sch->{'message'})	if $sch->{'message'};
		}
		print "\n</TABLE>\n</TD>\n";
	}
	print "\n</TABLE>\n";
	my $cal  = new Calendar ($year,$month);
	$days = $cal->{days};


	}else{

	# ڍ or ꗗ

	my $cal  = new Calendar ($year,$month);
	my $sch  = new Schedule ($dir,$year,$month,$admin);
	my $fday = $cal->{fday};
	$days = $cal->{days};

	# ꗗ\

	if($caltype ne 'Short'){
		print qq(<DIV class="events">),join(" / ",map{qq(<span class="sub$_">$events[$_]</span>)}(0..$#events)),"</DIV>";
		print qq(<table BORDER=1 cellspacing=0 align=left width="60%" class=calendar>\n<TR><TH width="1%" class="cal" nowrap>Day</TH><TH class="cal"> Schedule </TH></TR>\n);
		while(++$day <= $days){
			my $contents = 0;
			my $date = $year.$month.substr("0".$day,-2);
			my($special,$special_name) = $cal->search($day);


			my @gets_sp= @{$sch->get_sp_reserved($date)};


			my @gets   = @{$sch->get_reserved($date)};
			$special = "rest"	if $fday == 0;
			$special ="today"	if $date == $today;
			print "\n<TR><TD align=right valign=top class=$special nowrap><nobr>";
			print @gets == 0 ? "$day<span class=day>($days[$fday])</span>" : qq(<a href="$cgi_name?day_specified=$day&year=$year&month=$mon&form_on=$form_on">$day(<span class=day>$days[$fday])</span></a>);
			print "</nobr></TD><TD class=$special>";
			foreach my $name (@{$special_name}){
				print $name."<br>\n";
				$contents++;
			}
			foreach(@gets_sp){
				my($name,$mail,$subject,$content,$date) = (split /<>/)[0,1,3,4,5];
				$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
				$subject=~s/^(\d?)>(\w+)>//;
				$name = ""	if $1 == 1;
				print qq(<span class="$2">$subject</span> $name<br>\n);
				$contents++
			}
			foreach(@gets){
				my($name,$mail,$subject) = (split /<>/)[0,1,3];
				$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
				$subject=~s/^(\d+)>//;
#				my $event = "[$events[$1]]"	if $1 !=$#events;
				print qq(<span class="sub$1">$subject</span> $name<br>\n);
				$contents++
			}
			print $contents > 0 ? "</TD></TR>" : "@</TD></TR>";
			$fday = 0	if ++$fday > 6;
		}
	}else{

	# ڍו\

		print qq(<DIV class="simpledays">);
		while(++$day <= $days){
			my $day_ = $day;
			my $date = $year.$month.substr("0".$day,-2);
			my($color,$dummy) = $cal->search($day);
			$color = "rest"	if $cal->calc($day) == 0;
			$day_ = "&nbsp;".$day if length($day) ==1;
			$color = "today"	if $date == $today;
			print "<span class=$color>".$day_."</span> ";
		}
		print "</DIV>\n";
		print qq(<table BORDER=1 cellspacing=0 align=left width="60%">\n<TR><TH width="1%" nowrap class="cal">Day</TH><TH class="cal"> Schedule </TH></TR>\n);
		$day = 0;
		while(++$day <= $days){
			my $date = $year.$month.substr("0".$day,-2);
			my($special,$special_name) = $cal->search($day);
			my @gets_sp= @{$sch->get_sp_reserved($date)};
			my @gets   = @{$sch->get_reserved($date)};
			my $contents=0;
			$special = "rest"	if $fday == 0;
			$special = "today"	if $date == $today;
			if(@gets_sp > 0){
				foreach(@gets_sp){
					my($name,$mail,$subject,$content,$w_time) = (split /<>/)[0,1,3,4,5];
					$subject=~s/^(\d?)>(\w+)>//;
					if($2 eq "special2"){
						if($contents == 0){
							print "\n<TR><TD align=right valign=top class=$special nowrap><nobr>";
							print "$day<span class=day>($days[$fday])</span>";
							print "</nobr></TD><TD class=$special>";
						}
						$contents++;
						$w_time = time_convert($w_time);
						$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
						print $1 != 1 ? qq(<span class="$2">$subject</span> $name at $w_time<br><DIV class="content">$content</DIV>\n) : qq(<span class="$2">$subject</span><br>\n);
					}
				}
			}
			if(@gets > 0){
				if($contents == 0){
					print "\n<TR><TD align=right valign=top class=$special nowrap><nobr>";
					print "$day<span class=day>($days[$fday])</span>";
					print "</nobr></TD><TD class=$special>";
				}else{
					print "<br>";
				}
				print join("<br>\n",@{$special_name})."<br><br>\n"	if $special eq "special2";
				foreach(@gets){
					my($name,$mail,$subject,$content,$w_time) = (split /<>/)[0,1,3,4,5];
					$w_time = time_convert($w_time);
					$name = $mail ? qq( ( <A href="mailto:$mail">$name</a> )) : " ( $name )";
					$subject=~s/^(\d+)>//;
					my $event = "[$events[$1]]";
					print qq(<span class="sub$1">$event $subject</span> $name at $w_time<br><DIV class="content">$content</DIV>\n);
				}
				print "</TD></TR>";
			}
			$fday = 0	if ++$fday > 6;
			$day += 0;
		}
	}
	print "\n</TABLE>\n";
	push(@er_message,$sch->{'message'})	if $sch->{'message'};
	}

	# tH[\
	$, = "\n";
	print qq(<span class="error">).join("<br>\n",@er_message)."</span>";
	print qq(<table width="30%"><tr><td class="form">);
	print "<br>"	if $caltype eq '3month';
	print $cgi->startform(-method=>$method),
		$cgi->popup_menu(-name => 'year', -values => [$min .. $max],-default => $year),"/",
		$cgi->popup_menu(-name => 'month', -values => [qw(1 2 3 4 5 6 7 8 9 10 11 12)], -default=>$mon),"<br>",
		$cgi->submit(-value => 'ꗗ',-name=>'Long'),
		$cgi->submit(-value => 'ڍ',-name=>'Short'),
		$cgi->submit(-value => '3',-name=>'3month'),
		$cgi->reset(-value => 'Zbg'),"<br>\nݒ",
		$cgi->radio_group(-name =>'form_on',-values => [1,2],-labels=>{1=>'ʏ',2=>''}),
		$cgi->endform;
#	if($caltype ne '3month'){
#		print $cgi->startform(-method=>$method),
#				$cgi->hidden(-name=>'year',value=>$year),$cgi->hidden(-name=>'month',value=>$mon);
#		print $caltype eq "Long" ? $cgi->submit(-value=>' ڍ ',-name=>'Short') : $cgi->submit(-value=>' ꗗ ',-name=>'Long');
#		print $cgi->hidden(-value => $form_on,-name=>"form_on");
#		print $cgi->endform;
#	}
if($form_on == 1){
	print $cgi->startform(-method	=> $method2);
	print "<STRONG>ʏݒ</STRONG><br>\n";
	print $cgi->hidden(-name=>'CalType',-value=>$caltype),$year."/".$month."/".
		$cgi->popup_menu(
			-name   => "Date",
			-values => [ map{ $year.$month.substr("0".$_,-2) }(1..$days)],
			-labels => { map{ $year.$month.substr("0".$_,-2) => $_ }(1..$days)},
			-default=>$today
		),"<br>Ȃ܂<sup></sup><br>",
		$cgi->textfield(
			-name=>"name",
			-size=> 20,
			-default => $cookie{name}
		),"<br>E-Mail<br>",
		$cgi->textfield(
			-name=>"mail",
			-size=> 25,
			-default => $cookie{mail}
		),"<br>Cxg<br>",
		$cgi->popup_menu(
			-name   => "event",
			-values => ['',0..$#events],
			-labels => { '' => 'I',map{ $_ => shift(@events) }(0..$#events) },
		),"<br>薼<sup></sup><br>",
		$cgi->textfield(
			-name=>"subject",
			-size=> 30,
			-default => ''
		),"<br>e<sup></sup> (",
		$cgi->checkbox(
			-name => 'br',
			-value=> 'on',
			-label=> 'sȂ'
		),
		")<br>",
		$cgi->textarea(
			-name=>"content",
			-cols=> 30,
			-rows=> 4,
			-default => "",
		),"<br>pX[h<sup></sup><br>",
		$cgi->password_field(
			-name=>"pass",
			-size=> 10,
			-default => $cookie{pass}
		),"<br><br>",
		$cgi->submit(-value => "",-name=>'Write'),
		$cgi->submit(-value => "u",-name=>'Replace'),
		$cgi->submit(-value => "폜",-name=>'Delete'),
		$cgi->reset(-value => "Zbg"),"<br>I񂾓",
		$cgi->hidden(-value => $form_on,-name=>"form_on"),
		$cgi->textfield(
			-name => "del_num",
			-size => 3,
			-value=> 0,
			-default=>0
		),"Ԗڂɕ\\ĂXPW[ ( ʏݒŐݒ肵 ) Au/폜܂( 0͖ )B",$cgi->endform,"\n";
	$, = " ";
	word($month)	if @word > 0;
	print qq(<div align=center><a href="$back_link">$back_word</a><br><br></div>);
	print qq(\n<DIV align=center class=copyright>- <a href="http://www.pure.ne.jp/~learner/">Simple Scheduler $version</a> -</DIV>\n),
	"</td></tr></table>\n";
}elsif($form_on == 2){
	print $cgi->startform(-method	=> $method2);
	print "<strong>ݒ</strong><br>";
	print $cgi->hidden(-name=>'CalType',-value=>$caltype),
		$cgi->hidden(-name=>'TrueDate',-value=>$year.$month),
		"1.",$cgi->popup_menu(
			-name   => "Month",
			-values => ['',1..12,"*"],
			-labels => {''=>'I'}
		),"",
		$cgi->popup_menu(
			-name   => "Week",
			-values => [ '',0..4,"*" ],
			-labels => { ''=>'I'}
		),"T",
		$cgi->popup_menu(
			-name   => "Day",
			-values => [ '',0..6 ],
			-labels => { ''=>'I',0=>'',1=>'',2=>'',3=>'',4=>'',5=>'',6=>'y'}
		),"j","<br>2.",
		$cgi->popup_menu(
			-name   => "_Month",
			-values => ['',1..12,"*"],
			-labels => {''=>'I',}
		),"",
		$cgi->popup_menu(
			-name   => "_Day",
			-values => ['',1..31 ],
			-labels => {''=>'I',}
		),"<br>-- L͍폜ɕKvƂȂ܂ --<br>",
		$cgi->checkbox(
			-name => 'hanyo',
			-value=> '1',
			-label=> 'ėp'
		),"(O,Rg\\<span style=\"font-size:0.8em\">-OL͕K{-</span>)<br><br>",
		$cgi->popup_menu(
			-name   => 'event',
			-values => ['normal','special','special2'],
			-labels => {normal=>'ʏ',special=>'ʓ',special2=>'ʓ2'}
		),"<br><br>Ȃ܂<sup></sup><br>",
		$cgi->textfield(
			-name=>"name",
			-size=> 20,
			-default => $cookie{name}
		),"<br>E-Mail<br>",
		$cgi->textfield(
			-name=>"mail",
			-size=> 25,
			-default => $cookie{mail}
		),"<br>薼<sup></sup><br>",
		$cgi->textfield(
			-name=>"subject",
			-size=> 30,
			-default => ''
		),"<br>e<sup></sup> (",
		$cgi->checkbox(
			-name => 'br',
			-value=> 'on',
			-label=> 'sȂ'
		),
		")<br>",
		$cgi->textarea(
			-name=>"content",
			-cols=> 30,
			-rows=> 4,
			-default => "",
		),"<br>pX[h<sup></sup><br>",
		$cgi->password_field(
			-name=>"pass",
			-size=> 10,
			-default => $cookie{pass}
		),"<br><br>",
		$cgi->submit(-value => "",-name=>'SpWrite'),
		$cgi->submit(-value => "u",-name=>'SpReplace'),
		$cgi->submit(-value => "폜",-name=>'SpDelete'),
		$cgi->reset(-value => "Zbg"),"<br>12őI񂾏ƈv",
		$cgi->hidden(-value => $form_on,-name=>"form_on"),
		$cgi->textfield(
			-name => "del_num",
			-size => 3,
			-value=> 0,
			-default=>0
		),"Ԗڂɕ\\ĂݒAu/폜܂( 0͖ )B",$cgi->endform,"\n";
	$, = " ";
	word($month)	if @word > 0;
	print qq(<div align=center><a href="$back_link">$back_word</a><br><br></div>);
	print qq(\n<DIV align=center class=copyright>- <a href="http://www.pure.ne.jp/~learner/">Simple Scheduler $version</a> -</DIV>\n),
	"</td></tr></table>\n";
}else{
	print "</table>\n";
}
	print $cgi->end_html;
}# appear screen end

sub time_convert{
	my $t = shift;
	my @t = (gmtime $t+$time_d * 3600)[5,4,3,2,1];
	$t = ($t[0]+1900).'/'.(++$t[1]).'/'.$t[2].' '.substr("0".$t[3],-2).':'.substr("0".$t[4],-2);
	return $t;
}

sub word{
	my $month = shift;
	my $rando = int( rand(scalar @word) );
	if(open IN,$word[$rando]){
		print qq(\n<div class="word">\n);
		seek IN,0,0;
		while(<IN>){
			last if $_ eq $month."\n";
		}
		while(<IN>){
			last if $_ eq substr("0".($month+1),-2)."\n";
			print;
		}
		print "\n</div>\n";
	close IN};
}

sub make_pass{
	my $make_pass = 0;
	if($RS{pass} ne "" and $RS{pass} eq $RS{pass2}){
		$RS{pass} = Schedule::do_crypt($RS{pass});
		if(open OUT,">$dir/password"){
			print OUT $RS{pass};
			close OUT;
			$make_pass = 1;
			if(open LOCK,">$dir/unlock"){
				close LOCK
			}else{
				push(@er_message,"$dir/unlock쐬sBōĉB");
			}
		}else{
			push(@er_message,"Can't make a new file(main::make_pass)");
		}
	}else{
			push(@er_message,'pX[hłB')							if exists $RS{pass} and $RS{pass} eq "";
			push(@er_message,'pX[hPԖڂƂQԖڂňقȂĂ܂B')	if $RS{pass} ne "";
	}

	if(!$make_pass){
	$, = "\n";
	print $cgi->header(-title=>'password setting'),
		$cgi->start_html,
		$cgi->h1('Password Setting'),
		join("",@er_message),
		$cgi->start_form(-method =>$method2),
		$cgi->password_field(-name =>'pass'),"<br>",
		$cgi->password_field(-name =>'pass2'),"<br>",
		$cgi->submit(-value=>'send'),
		$cgi->reset(-value=>'Reset'),
		$cgi->end_form,
		$cgi->end_html;
	$,= " ";
	}else{
		appear();
	}
}
